#![allow(deprecated)]
use std::fmt;
use std::str;
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde")]
pub enum AggregateType {
    #[serde(rename = "TOTAL_DURATION")]
    TotalDuration,
    #[serde(rename = "TOTAL_COUNT")]
    TotalCount,
    /// An unknown variant.
    #[serde(untagged)]
    Unknown(Unknown),
}
impl AggregateType {
    /// Returns the string representation of the enum.
    #[inline]
    pub fn as_str(&self) -> &str {
        match self {
            AggregateType::TotalDuration => "TOTAL_DURATION",
            AggregateType::TotalCount => "TOTAL_COUNT",
            AggregateType::Unknown(v) => &*v,
        }
    }
}
impl fmt::Display for AggregateType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        fmt::Display::fmt(self.as_str(), fmt)
    }
}
impl conjure_object::Plain for AggregateType {
    fn fmt(&self, fmt: &mut fmt::Formatter) -> fmt::Result {
        conjure_object::Plain::fmt(self.as_str(), fmt)
    }
}
impl str::FromStr for AggregateType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_str(
        v: &str,
    ) -> Result<AggregateType, conjure_object::plain::ParseEnumError> {
        match v {
            "TOTAL_DURATION" => Ok(AggregateType::TotalDuration),
            "TOTAL_COUNT" => Ok(AggregateType::TotalCount),
            v => v.parse().map(|v| AggregateType::Unknown(Unknown(v))),
        }
    }
}
impl conjure_object::FromPlain for AggregateType {
    type Err = conjure_object::plain::ParseEnumError;
    #[inline]
    fn from_plain(
        v: &str,
    ) -> Result<AggregateType, conjure_object::plain::ParseEnumError> {
        v.parse()
    }
}
///An unknown variant of the AggregateType enum.
#[derive(
    Debug,
    Clone,
    PartialEq,
    Eq,
    PartialOrd,
    Ord,
    Hash,
    conjure_object::serde::Deserialize,
    conjure_object::serde::Serialize,
)]
#[serde(crate = "conjure_object::serde", transparent)]
pub struct Unknown(conjure_object::private::Variant);
impl std::ops::Deref for Unknown {
    type Target = str;
    #[inline]
    fn deref(&self) -> &str {
        &self.0
    }
}
impl fmt::Display for Unknown {
    #[inline]
    fn fmt(&self, fmt: &mut fmt::Formatter<'_>) -> fmt::Result {
        fmt::Display::fmt(&self.0, fmt)
    }
}
